
#include "Form.h"
#include "AlertEx.h"


static Err RegisterNotify( UInt16* pTrapButtons );
static Err UnregisterNotify( );
static Err OnNotify( SysNotifyParamType* pParams );



UInt16 FrmAlertEx( UInt16 id, UInt16* pTrapButtons ) {
	UInt16 ret = 0;
	if( !!pTrapButtons )
		RegisterNotify( pTrapButtons );
	ret = FrmAlert( id );
	if( !!pTrapButtons )
		UnregisterNotify( );
	return ret;
}

UInt16 FrmCustomAlertEx( UInt16 id, UInt16* pTrapButtons,
						 const char* s1, const char* s2, const char* s3 ) {
	UInt16 ret = 0;
	if( !!pTrapButtons )
		RegisterNotify( pTrapButtons );
	ret = FrmCustomAlert( id, s1, s2, s3 );
	if( !!pTrapButtons )
		UnregisterNotify( );
	return ret;
}

UInt16 FrmCustomResponseAlertEx( UInt16 id, UInt16* pTrapButtons,
								 const char* s1, const char* s2, const char* s3,
								 char* pBuf, Int16 bufLen,
								 FormCheckResponseFuncPtr pCallback ) {
	UInt16 ret = 0;
	if( !!pTrapButtons )
		RegisterNotify( pTrapButtons );
	ret = FrmCustomResponseAlert( id, s1, s2, s3, pBuf, bufLen, pCallback );
	if( !!pTrapButtons )
		UnregisterNotify( );
	return ret;
}

static Err RegisterNotify( UInt16* pTrapButtons ) {
	UInt16	cardNo;
	LocalID	dbID;
	SysCurAppDatabase( &cardNo, &dbID );
	return SysNotifyRegister( cardNo, dbID, 
							  sysNotifyVirtualCharHandlingEvent,
							  OnNotify, sysNotifyNormalPriority,
							  (void*)pTrapButtons ); 
}

static Err UnregisterNotify( ) {
	UInt16	cardNo;
	LocalID	dbID;
	SysCurAppDatabase( &cardNo, &dbID );
	return SysNotifyUnregister( cardNo, dbID,
								sysNotifyVirtualCharHandlingEvent,
								sysNotifyNormalPriority ); 
}

static Err OnNotify( SysNotifyParamType* pParams ) {

	SysNotifyVirtualCharHandlingType* p = NULL;
	UInt16*			pTrapBtns	= NULL;
	int				idx			= 0;
	FormType* 		pForm		= NULL;
	UInt16			objIndex	= 0;
	ControlType*	pControl	= NULL;
	
	if( pParams->notifyType != sysNotifyVirtualCharHandlingEvent )
		return errNone;

	pTrapBtns = (UInt16*)( pParams->userDataP );
	if( !pTrapBtns )
		return errNone;

	p = (SysNotifyVirtualCharHandlingType*)( pParams->notifyDetailsP );
	if( !p )
		return errNone;

	for( idx = 0; pTrapBtns[idx] != 0; ++idx ) {
		if( pTrapBtns[idx] == p->keyDown.chr ) {
			pParams->handled = true;
			pForm = FrmGetActiveForm( );
			if( !pForm )
				break;
			objIndex = FrmGetObjectIndex( pForm, 12004 + idx );
			if( objIndex == (UInt16)-1 )
				break;
			pControl = (ControlType*)( FrmGetObjectPtr( pForm, objIndex ) );
			if( !pControl )
				break;
			CtlHitControl( pControl );
			break;
		}
	}

	return errNone;

}
